namespace Parsing.Schema.BuildingBlocks;

using Parsing.Tokenization;

public interface IBuildingBlock
{
    public List<IToken> ParseWord(InputProvider inputs);

    public bool CanParseWord(InputProvider inputs);

    public bool CanParseWord(string word);

    public BlockType GetBlockType();

    public bool IsRepetitionType();

    public bool CheckIsDoneParsingAndReset(InputProvider inputs);
}