﻿namespace Parsing.Tokenization;

using System.Runtime.CompilerServices;
using Parsing.Schema;

public class Fragment : Dictionary<string, List<string>>
{
}

public class FragmentToken : IValueToken<Fragment>
{
    private string word;
    private Fragment matches = new Fragment();

    public FragmentToken(string word)
    {
        this.word = word;
    }

    public string GetText()
    {
        return word;
    }

    public void AddMatch(string name, List<string> values)
    {
        this.matches.Add(name, values);
    }

    public Fragment GetValue()
    {
        return this.matches;
    }

    public InputType GetInputType()
    {
        return InputType.Fragment;
    }
}
