﻿namespace Parsing.Tokenization;

using Parsing.Schema;

public class IntegerToken : IValueToken<int>
{
    private string word;

    public IntegerToken(string word)
    {
        this.word = word;
    }

    public string GetText()
    {
        return word;
    }

    public int GetValue()
    {
        return int.Parse(word);
    }

    public InputType GetInputType()
    {
        return InputType.Integer;
    }
}
